//////////////////////////////////////////////////////////////////////////////////////////////
// Copyright 2018 Leszek Koltunski                                                          //
//                                                                                          //
// This file is part of Distorted.                                                          //
//                                                                                          //
// Distorted is free software: you can redistribute it and/or modify                        //
// it under the terms of the GNU General Public License as published by                     //
// the Free Software Foundation, either version 2 of the License, or                        //
// (at your option) any later version.                                                      //
//                                                                                          //
// Distorted is distributed in the hope that it will be useful,                             //
// but WITHOUT ANY WARRANTY; without even the implied warranty of                           //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                            //
// GNU General Public License for more details.                                             //
//                                                                                          //
// You should have received a copy of the GNU General Public License                        //
// along with Distorted.  If not, see <http://www.gnu.org/licenses/>.                       //
//////////////////////////////////////////////////////////////////////////////////////////////

precision highp float;
precision highp int;

out vec4 fragColor;
in vec2 v_TexCoordinate;

uniform vec2 u_Size;

layout (std430,binding=1) buffer linkedlist
  {
  uint u_Records[];
  };

//////////////////////////////////////////////////////////////////////////////////////////////

void main()                    		
  {
  uint pixelX = uint(v_TexCoordinate.x * u_Size.x);
  uint pixelY = uint(v_TexCoordinate.y * u_Size.y);
  uint index  = pixelX + pixelY * uint(u_Size.x);

  uint ptr = u_Records[index];

       if( u_Records[ptr]==2u ) fragColor = vec4(1.0,0.0,0.0,1.0);
  else if( u_Records[ptr]==1u ) fragColor = vec4(0.0,1.0,0.0,1.0);
  else                          fragColor = vec4(0.0,0.0,1.0,1.0);
  }